package com.capitalware.ufmsm.objects;

import java.io.File;

/**
 * This class holds all the constants used in UFM Status Monitor
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class CWConstants
{
   public static final String    PRODUCT_NAME = "UFM Status Monitor";
   public static final String    VERSION = "2.0.0";
   public static final String    RELEASE_DATE = "2019/03/19";
   public static final String    COPYRIGHT_DATE = "2012-2019";
   
   public static final String    MQ_PATH = System.getProperty("user.dir") + File.separator + "mq" + File.separator;

   public static final String    MQ_DTD            = "UFM_SM_MQ.dtd";

   public static final int       MAIN_MIN_WIDTH    = 875;
   public static final int       MAIN_MIN_HEIGHT   = 500;
   
   public static final int       WK_MIN_WIDTH      = 840;
   public static final int       WK_MIN_HEIGHT     = 350;
   
   public static final int       ADD_MIN_WIDTH     = 450;
   public static final int       ADD_MIN_HEIGHT    = 450;

   // column number                                                0,  1,  2, 3, 4, 5, 6,  7
   public final static int[]     statusQcolumnWidth  = new int[]{110,175,100,75,90,75,75,220};
   public final static int[]     workflowcolumnWidth = new int[]{110,70,75,75,75,300};

   public final static int       statusQcolumns    = 8 + 1;  // +1 is for correlID 
   public final static int       workflowcolumns   = 5 + 1;  // +1 is for parameters

   /**
    * MQ Elements
    */
   public static final String REFRESH_RATE_ELEMENT       = "RefreshRate";
   
   public static final String MQ_ELEMENT                 = "MQ";
   public static final String MQFILE_ELEMENT             = "MQFile";
   public static final String CCDTFILE_ELEMENT           = "CCDTFile";
   public static final String QMGRNAME_ELEMENT           = "QMgrName";
   public static final String QUEUENAME_ELEMENT          = "QueueName";
   public static final String HOSTNAME_ELEMENT           = "Hostname";
   public static final String PORT_ELEMENT               = "Port";
   public static final String USERID_ELEMENT             = "UserID";
   public static final String PASSWORD_ELEMENT           = "Password";
   //
   public static final String CHANNELNAME_ELEMENT        = "ChannelName";
   public static final String SECURITYEXIT_ELEMENT       = "SecurityExit";
   public static final String SECURITYEXITPATH_ELEMENT   = "SecurityExitPath";
   public static final String SECURITYEXITDATA_ELEMENT   = "SecurityExitData";
   public static final String CIPHERSUITENAME_ELEMENT    = "CipherSuiteName";
   public static final String DISTINGUISHEDNAME_ELEMENT  = "DistinguishedName";
   public static final String TRUSTEDSTORE_ELEMENT       = "TrustedStore";
   public static final String TRUSTEDSTOREPASSWD_ELEMENT = "TrustedStorePasswd";
   public static final String KEYSTORE_ELEMENT           = "KeyStore";
   public static final String KEYSTOREPASSWD_ELEMENT     = "KeyStorePasswd";
   public static final String LDAPSERVER_ELEMENT         = "LDAPServer";
   public static final String LDAPSERVERPORT_ELEMENT     = "LDAPServerPort";
}
