package com.capitalware.ufmsm.popups;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import com.capitalware.ufmsm.UFMSM;

/**
 * This class will display an "About Box" to the user.
 *
 * @author Roger Lacroix, Capitalware Inc.
 * @version 1.0.0
 * @license Apache 2 License
 */
public class AboutBox extends JDialog
{
   /**
    * The constructor
    * @param owner
    * @param _name
    * @param _version
    */
   public AboutBox(Frame parent, String _name, String _version, String releaseDate, String copyright, String gifName)
   {
      super(parent, false);

      setTitle("About");

      GridBagConstraints gbc = new GridBagConstraints();
      getContentPane().setLayout(new GridBagLayout());

      gbc.anchor = GridBagConstraints.NORTH;
      gbc.weightx = 0;
      gbc.weighty = 0;
      gbc.fill = GridBagConstraints.NONE;
      gbc.insets = new Insets(0,5,0,5);  // Top, Left, Bottom, Right

      JLabel lbl = new JLabel(new ImageIcon(UFMSM.class.getResource(gifName)));
      JPanel p = new JPanel();
      Border b1 = new BevelBorder(BevelBorder.LOWERED);
      Border b2 = new EmptyBorder(5, 5, 5, 5);
      lbl.setBorder(new CompoundBorder(b1, b2));
      p.add(lbl);
//      getContentPane().add(p, BorderLayout.WEST);
      add(p, gbc, 0, 0, 1, 15);    // c , r, cw, rh

      gbc.anchor = GridBagConstraints.WEST;
      gbc.weightx = 0;
      gbc.weighty = 0;
      gbc.fill = GridBagConstraints.NONE;
      gbc.insets = new Insets(0,5,0,10);  // Top, Left, Bottom, Right

      String message = _name;
      JLabel txt1 = new JLabel(message);
      txt1.setFont(new Font("Helvetica", Font.BOLD, 12));
      txt1.setForeground(Color.black);
      add(txt1, gbc, 1, 0, 1, 1);    // c , r, cw, rh

      message = "Version: " + _version;
      JLabel txt1b = new JLabel(message);
      txt1b.setFont(new Font("Helvetica", Font.BOLD, 12));
      txt1b.setForeground(Color.black);
      add(txt1b, gbc, 1, 1, 1, 1);    // c , r, cw, rh

      message = "Released: " + releaseDate;
      JLabel txt2 = new JLabel(message);
      txt2.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt2.setForeground(Color.black);
      add(txt2, gbc, 1, 2, 1, 1);    // c , r, cw, rh

      message = "Copyright: " + copyright;
      JLabel txt3 = new JLabel(message);
      txt3.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt3.setForeground(Color.black);
      add(txt3, gbc, 1, 3, 1, 1);    // c , r, cw, rh

      gbc.insets = new Insets(10,5,0,10);  // Top, Left, Bottom, Right

      message = "Capitalware Inc.";
      JLabel txt4 = new JLabel(message);
      txt4.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt4.setForeground(Color.black);
      add(txt4, gbc, 1, 4, 1, 1);    // c , r, cw, rh

      gbc.insets = new Insets(0,5,0,10);  // Top, Left, Bottom, Right

      message = "Unit 11, 1673 Richmond Street, PMB524";
      JLabel txt5 = new JLabel(message);
      txt5.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt5.setForeground(Color.black);
      add(txt5, gbc, 1, 5, 1, 1);    // c , r, cw, rh

      message = "London, Ontario N6G2N3 Canada";
      JLabel txt6 = new JLabel(message);
      txt6.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt6.setForeground(Color.black);
      add(txt6, gbc, 1, 6, 1, 1);    // c , r, cw, rh

      message = "https://www.capitalware.com";
      JLabel txt7 = new JLabel(message);
      txt7.setFont(new Font("Helvetica", Font.PLAIN, 14));
      txt7.setForeground(Color.black);
      add(txt7, gbc, 1, 7, 1, 1);    // c , r, cw, rh

      gbc.insets = new Insets(10,5,0,10);  // Top, Left, Bottom, Right

      message = "Support:";
      JLabel txt8 = new JLabel(message);
      txt8.setFont(new Font("Helvetica", Font.BOLD, 12));
      txt8.setForeground(Color.black);
      add(txt8, gbc, 1, 8, 1, 1);    // c , r, cw, rh

      gbc.insets = new Insets(0,5,0,10);  // Top, Left, Bottom, Right

      message = "mailto:support@capitalware.com";
      JLabel txt9 = new JLabel(message);
      txt9.setFont(new Font("Helvetica", Font.PLAIN, 14));
      txt9.setForeground(Color.black);
      add(txt9, gbc, 1, 9, 1, 1);    // c , r, cw, rh

      message = "http://www.capitalware.com/forum.html";
      JLabel txt10 = new JLabel(message);
      txt10.setFont(new Font("Helvetica", Font.PLAIN, 14));
      txt10.setForeground(Color.black);
      add(txt10, gbc, 1, 10, 1, 1);    // c , r, cw, rh

      gbc.insets = new Insets(10,5,0,10);  // Top, Left, Bottom, Right

      message = "JVM version " + System.getProperty("java.version");
      JLabel txt11 = new JLabel(message);
      txt11.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt11.setForeground(Color.black);
      add(txt11, gbc, 1, 11, 1, 1);    // c , r, cw, rh

      gbc.insets = new Insets(0,5,0,10);  // Top, Left, Bottom, Right

      message = "by " + System.getProperty("java.vendor");
      JLabel txt12 = new JLabel(message);
      txt12.setFont(new Font("Helvetica", Font.PLAIN, 12));
      txt12.setForeground(Color.black);
      add(txt12, gbc, 1, 12, 1, 1);    // c , r, cw, rh

      JButton btOK = new JButton("Ok");
      ActionListener lst = new ActionListener()
      {
         public void actionPerformed(ActionEvent e)
         {
            dialogCleanUp();
         }
      };
      btOK.addActionListener(lst);
      gbc.insets = new Insets(15,5,0,5);  // Top, Left, Bottom, Right
      add(btOK, gbc, 1, 13, 1, 1);    // c , r, cw, rh

      //
      addWindowListener(new WindowAdapter()
      {
         public void windowClosing(WindowEvent we)
         {
            dialogCleanUp();
         }
      });

      setSize(350,350);  // w * h
      setResizable(false);
      if (parent != null)
          setLocationRelativeTo(parent);

      //
      getOwner().setEnabled(false);
   }

   /**
    * Add a component to the main pane.
    * @param c
    * @param gbc
    * @param x
    * @param y
    * @param w
    * @param h
    */
   private void add(Component c, GridBagConstraints gbc, int x, int y, int w, int h)
   {
      gbc.gridx = x;
      gbc.gridy = y;
      gbc.gridwidth = w;
      gbc.gridheight = h;
      getContentPane().add(c, gbc);
   }

   /**
    * Time to enable our parent and throw ourselves away.
    */
   private void dialogCleanUp()
   {
      getOwner().setEnabled(true);
      this.hide();
   }
}
